const postcss = require('postcss');
const selectorParser = require('postcss-selector-parser');
const postcssMpvueWxss = require('postcss-mpvue-wxss');

// const replaceCharInSelector = {:'+'}
const invaildColStr = ' > [class*="col-"]';
const invaildColStrCmprsed = '>[class*="col-"]';
const colSelectorsStr =  '.col-1,.col-2,.col-3,.col-4,.col-5,.col-6,.col-7,.col-8,.col-9,.col-10,.col-11,.col-12,' +
  ' .col-auto,.col-sm-1,.col-sm-2,.col-sm-3,.col-sm-4,.col-sm-5,.col-sm-6,.col-sm-7,.col-sm-8,.col-sm-9,.col-sm-10,.col-sm-11,.col-sm-12,.col-sm,' +
  '.col-sm-auto,.col-md-1,.col-md-2,.col-md-3,.col-md-4,.col-md-5,.col-md-6,.col-md-7,.col-md-8,.col-md-9,.col-md-10,.col-md-11,.col-md-12,.col-md,' +
  '.col-md-auto,.col-lg-1,.col-lg-2,.col-lg-3,.col-lg-4,.col-lg-5,.col-lg-6,.col-lg-7,.col-lg-8,.col-lg-9,.col-lg-10,.col-lg-11,.col-lg-12,.col-lg,' +
  '.col-lg-auto,.col-xl-1,.col-xl-2,.col-xl-3,.col-xl-4,.col-xl-5,.col-xl-6,.col-xl-7,.col-xl-8,.col-xl-9,.col-xl-10,.col-xl-11,.col-xl-12,.col-xl,' +
  '.col-xl-auto';
const colSelectors = colSelectorsStr.split(',');

module.exports = postcss.plugin('postcss-bootstrap-wxss', options => {
  // Work with options here
  // options = Object.assign({}, defConfig, options);
  return function (root) {

    root.walkRules(rule => {
      const { selector } = rule || {};
      if(hasInvaildColStr(rule.selector)) {

        var ruleSelectors = rule.selector.split(',');
        var safeColSelectors = [];
        ruleSelectors.forEach(function (ruleSelector) {
          if(hasInvaildColStr(ruleSelector)){
            var parentSelector = ruleSelector.replace(invaildColStr, '');
            parentSelector = parentSelector.replace(invaildColStrCmprsed, '');
            var unfoldSelectors = colSelectors.map( colSelector => parentSelector+' > '+colSelector);
            safeColSelectors = safeColSelectors.concat(unfoldSelectors);
          }else{
            safeColSelectors.push(ruleSelector);
          }
        });
        // var safeColSelectors = [];
        // colSelectors.forEach(function (colSelector) {
        //   safeColSelectors.push(parentSelector+' > '+colSelector);
        // });
        rule.selector =  safeColSelectors.join(', ');
      }

      rule.selector = rule.selector.replace(/.~/ig, str => {
        return '+';
      });

      /*

            for (var k in replaceCharInSelector) {
              if (replaceCharInSelector.hasOwnProperty(k)) {
              }
            }

            if(hasInvaildChar(rule.selector)) {
              rule.selector = selectorParser(function (selectors) {
                selectors.each(function (selector) {
                  selector.each(function (n) {
                    // 转换 tag 选择器
                    if (n.type === 'tag') {
                      const k = n.value;
                    }
                    // 清理不支持的选择器
                    if ([].includes(n.value)) {
                      // return n.value = 'view';
                      return rule.remove();
                    }
                  })
                })
              }).process(selector).result;
            }*/
    });
  };
});


function hasInvaildColStr(selector) {
  return selector.indexOf(invaildColStr) > 0 || selector.indexOf(invaildColStrCmprsed) > 0;
}
/*
function hasInvaildChar(selector) {
  for (var k in replaceCharInSelector) {
    if (replaceCharInSelector.hasOwnProperty(k) && selector.indexOf(replaceCharInSelector[k]) >0 ) {
      return true;
    }
  }
  return false;
}*/
